using System;
using System.Collections.Generic;
using System.Text;

namespace CricketScores
{
    /// <summary>
    /// Shows value type behaviour of structures
    /// </summary>
    class ScoreCalculator
    {
        struct Player
        {
            public string PlayerName;
            public int ScoreInRuns;
            public int InningsLengthInMins;
            public static bool operator == (Player a, Player b)
            {
                // If both are null, or both are same instance, return true.
                if (System.Object.ReferenceEquals(a, b))
                {
                    return true;
                }

                // If one is null, but not both, return false.
                if (((object)a == null) || ((object)b == null))
                {
                    return false;
                }

                // Return true if the fields match:
                return a.PlayerName == b.PlayerName && 
                    a.ScoreInRuns == b.ScoreInRuns && 
                    a.InningsLengthInMins == b.InningsLengthInMins;
            }

            public static bool operator !=(Player a, Player b)
            {
                // If both are null, or both are same instance, return true.
                if (System.Object.ReferenceEquals(a, b))
                {
                    return false;
                }

                // If one is null, but not both, return false.
                if (((object)a == null) || ((object)b == null))
                {
                    return true;
                }

                // Return true if any of the fields don't match:
                return a.PlayerName != b.PlayerName ||
                    a.ScoreInRuns != b.ScoreInRuns ||
                    a.InningsLengthInMins != b.InningsLengthInMins;
            }

            public override bool Equals(object obj)
            {
                return base.Equals(obj);
            }
        }
        static void Main(string[] args)
        {
            Player p1, p2, p3;
            p1.PlayerName = "Fred";
            p1.ScoreInRuns = 100;
            p1.InningsLengthInMins = 120;
            p2 = p1;
            p2.PlayerName = "Jim";
            Console.WriteLine ( "Player 1 name : {0}", p1.PlayerName);
            p3 = p1;
            if (p1 == p3)
            {
                Console.WriteLine("Test 1 : Equal");
            }
            p3 = p1;
            p3.PlayerName = "Ethel";
            if (p1 == p3)
            {
                Console.WriteLine("Test 2 : Equal");
            }

        }
    }
}
