using System;
using System.Collections.Generic;
using System.Text;


namespace DelegateDesign
{

    public delegate void CheckResult(string inputString);

    class CheckException : System.Exception
    {
        string CheckMessage;

        public CheckException(string inMessage)
        {
            CheckMessage = inMessage;
        }
    }

    class Program
    {
        public void EmptyStringCheck(string inputString )
        {
            System.Console.WriteLine("Empty String Check Called");

            if (inputString.Trim().Length == 0)
            {
                throw new CheckException("Empty String");
            }
        }

        public void DigitsOnlyCheck(string inputString)
        {
            System.Console.WriteLine("Digits Only Check Called");
            try
            {
                int.Parse(inputString);
            }
            catch
            {
                throw new CheckException("Does not contain just digits");
            }
        }

        public void DemonstrateDelegates()
        {
            CheckResult CheckMethod;
            CheckMethod = new CheckResult(EmptyStringCheck);
            CheckMethod += new CheckResult(DigitsOnlyCheck);
            CheckMethod("1");
            CheckMethod("");
        }

        static void Main(string[] args)
        {
            Program p = new Program();

            p.DemonstrateDelegates();
        }
    }
}
