using System;
using LibraryBusiness;

namespace TestHarness
{
	/// <summary>
	/// Tests the behaviour of the business objects
	/// </summary>
	class TestClass
	{

		/// <summary>
		/// Creates a title and then verifies that the title
		/// information has been set correctly.
		/// </summary>
		static private void TestTitle () 
		{
			Title t = new Title("War and Peace");
			if ( t.Name != "War and Peace" ) 
			{
				Console.WriteLine ( "Title test failed" );
			}
		}

		/// <summary>
		/// Creates a title and then adds four books to it
		/// </summary>
		static private void TestBook ()
		{
			Title t = new Title ("War of the Worlds");

			Book b1 = new Book ( 1, t );
			Book b2 = new Book ( 2, t );
			Book b3 = new Book ( 3, t );
			Book b4 = new Book ( 4, t );

			t.AddBook (b1);
			t.AddBook (b2);
			t.AddBook (b3);
			t.AddBook (b4);

			Console.WriteLine(t);

		}
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			Console.WriteLine("Tests Starting");
			TestTitle();
			TestBook();
			Console.ReadLine();
		}
	}
}
