using System;
using GameClubBusinessObjects;

namespace GameClubControlClasses
{

	public interface IMakeReservationMessages 
	{
		bool FindMemberByName ( string name ) ;
		bool FindTitleByName ( string name ) ;
		bool ReserveTitle () ;
	}

	/// <summary>
	/// Makes a reservation for a game for a particular member
	/// </summary>
	public class MakeReservation : IMakeReservationMessages 
	{
		GameClub club;
		ClubMember member = null;
		Title title = null;
		Reservation result = null;

		public Reservation Result 
		{
			get 
			{
				return result;
			}
		}

		public bool FindMemberByName ( string name ) 
		{
			member = club.FindMemberByName(name);
			if ( member == null ) 
			{
				return false;
			}
			return true;
		}

		public bool FindTitleByName ( string name ) 
		{
			title = club.FindTitleByName ( name ) ;
			if ( title == null ) 
			{
				return false;
			}
			return true;
		}

		public bool ReserveTitle () 
		{
			if ( member == null ) 
			{
				return false;
			}
			if ( title == null ) 
			{
				return false;
			}

			result = new Reservation ( member, title ) ;

			if ( result == null ) 
			{
				return false;
			}
			
			return true;
		}

		public MakeReservation( GameClub inClub )
		{
			club = inClub;
		}
	}
}
